#include <stdio.h>
#include <subRecord.h>
#include <aSubRecord.h>

#include <socan.h>

#if 0
int timestamp(struct subRecord *psub)
  { /* get CAN object timestamp,
       A: port
       B: COB
       val: timestamp */
    unsigned long ts;
    char buf[40];
    socan_rc rc= socan_obj_ts((unsigned char)(psub->a),
                              (unsigned short)(psub->b),
                              &ts);
    if (socan_rc_is_error(rc))
      {
        printf("timestamp error, port %d, cob:%d, rc: %d (%s)\n",
               (unsigned char)(psub->a),
               (unsigned short)(psub->b),
               rc, socan_str_rc(rc));
        psub->val= 0;
        return 0;
      }
    socan_ts_to_str(ts, buf, 40);
    /* printf("ts: %lu  %s\n", ts, buf); */
    psub->c= ts >> 32;
    psub->val= ts & 0xFFFFFFFF;
    return 0;
  }
#endif

int timestamp(struct aSubRecord *psub)
  { /* get CAN object timestamp,
       A: port
       B: COB
       val: timestamp */
    unsigned long ts;
    char buf[40];
    socan_rc rc= socan_obj_ts(*((unsigned char *)(psub->a)),
                              *((unsigned short *)(psub->b)),
                              &ts);
    if (socan_rc_is_error(rc))
      {
        printf("timestamp error, port %d, cob:%d, rc: %d (%s)\n",
               *((unsigned char*)(psub->a)),
               *((unsigned char*)(psub->b)),
               rc, socan_str_rc(rc));
        psub->val= 0;
        return 0;
      }
    /* VALA will hold the human-readable timestamp. */
    socan_ts_to_str(ts, (char*)(psub->vala), 40);
    /* printf("ts: %lu  %s\n", ts, buf); */
    return 0;
  }

int littleendian_counter(struct subRecord *psub)
  {
    static unsigned int counter=0;

    counter+= 1;
    /*printf("CNT: %4x\n", counter);*/

    psub->val= counter;
    return(0);
  }

int bigendian_counter(struct subRecord *psub)
  {
    static unsigned int counter=0;
    int counter_be; /* note: signed int is important here!! */

    counter+= 1;

    /* convert to big endian: */
    counter_be= ((counter & 0xFF) << 24) | ((counter & 0xFF00) << 8) | ((counter & 0xFF0000) >> 8) | ((counter & 0xFF000000) >> 24);
    /*printf("CNT: %4x   BE: %4x\n", counter, counter_be);*/

    psub->val= counter_be;
    return(0);
  }

#include <registryFunction.h>
#include <epicsExport.h>

epicsRegisterFunction(littleendian_counter);
epicsRegisterFunction(bigendian_counter);
